#include <asm/io.h>
#include <stdio.h>
#include <math.h>

void hilfe(char *name){
    printf("lpswitch by Kai Fett, kf@schnism.net. This tool is free for any use.\n\n");
    printf("Syntax: %s PORT SWITCH on|off\n\n",name);
    
    printf("     where PORT   is the # of your lp-Port, 0, 1 or 2\n");
    printf("           SWITCH is the switch you want to switch\n\n");
    exit(1);
}


main(int argc, char **argv){
  int base, value;
  
  if (argc != 4) {
    hilfe(argv[0]);
  } else {
    base=0;
    if (*argv[1] == '0'){base=0x3bc;}
    if (*argv[1] == '1'){base=0x378;}
    if (*argv[1] == '2'){base=0x278;}
    if (base == 0){hilfe(argv[0]);}

    if (ioperm(base, 1, 1)) {perror("ioperm"); exit(1);}             
    value=inb(base);
    
    if (*argv[3] == '1'){
      if (*argv[2] == '1'){value=value | 1;}
      if (*argv[2] == '2'){value=value | 2;}
      if (*argv[2] == '3'){value=value | 4;}
      if (*argv[2] == '4'){value=value | 8;}
      if (*argv[2] == '5'){value=value | 16;}
      if (*argv[2] == '6'){value=value | 32;}
      if (*argv[2] == '7'){value=value | 64;}
      if (*argv[2] == '8'){value=value | 128;}
    } else {
      if (*argv[2] == '1'){value=value & ~1;}
      if (*argv[2] == '2'){value=value & ~2;}
      if (*argv[2] == '3'){value=value & ~4;}
      if (*argv[2] == '4'){value=value & ~8;}
      if (*argv[2] == '5'){value=value & ~16;}
      if (*argv[2] == '6'){value=value & ~32;}
      if (*argv[2] == '7'){value=value & ~64;}
      if (*argv[2] == '8'){value=value & ~128;}
                                                    
    }
         
    outb(value, base);             
  }
}